unit prompt2;

{

    Copyright (C) 1994 Matthias S. Benkmann <m.s.b@gmx.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License,
    NOT any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}


interface

uses crt;

const
  enableesc:boolean=true;
  charbag:string='';

function editstring(var s:string;maxlen:byte;def:boolean):boolean;
function readshortint(var retval:shortint;def:boolean):boolean;
function readbyte(var retval:byte;def:boolean):boolean;
function readint(var retval:integer;def:boolean):boolean;
function readword(var retval:word;def:boolean):boolean;
function readlongint(var retval:longint;def:boolean):boolean;
function readreal(var retval:real;def:boolean):boolean;

implementation

uses dos;

var
  typ:byte;
  ergint:longint;
  ergreal:real;

PROCEDURE SETCURSOR(START,STOP:BYTE);
var
  reg:registers;
begin
  reg.ah:=1;
  reg.ch:=start;
  reg.cl:=stop;
  intr($10,reg);
end;

PROCEDURE INVERSETEXT;
var
  b:byte;
begin
  b:=byte(textattr shr 4);
  textattr:=byte(textattr shl 4);
  inc(textattr,b);
end;

FUNCTION STRX(L:LONGINT):STRING;
var s:string;
begin
  str(l,s);
  strx:=s;
end;


procedure chgcur(ins:boolean);
begin
  if ins then setcursor(6,7) else setcursor(0,7);
end;


function editstring(var s:string;maxlen:byte;def:boolean):boolean;
var
  curx,cury,curpos:byte;
  ch:char;
  ins:boolean;
  slen:byte absolute s;
  trottel:word;
  vram:array[0..10000] of byte absolute $b800:0;
begin
  if def=false then s:='';
  ins:=true;
  if slen<maxlen then curpos:=succ(slen) else curpos:=slen;
  write('':maxlen);
  trottel:=(wherey-1)*80+wherex-1;
  setcursor(6,7);
  dec(trottel,maxlen);
  curx:=(trottel mod 80)+1;
  cury:=(trottel div 80)+1;
  gotoxy(curx,cury);
  inversetext;
  write(s);
  inversetext;
  gotoxy(curx+curpos-1,cury);
  ch:=readkey;
  if (pos(ch,charbag)<>0) or ((charbag='') and not(ch in [#27,#13,#9,#25,#0,#8])) then
  begin
    s:='';
    curpos:=1;
  end;
  repeat
    case ch of
      #0: begin
            ch:=readkey;
            case ch of
              #75 : if curpos>1 then dec(curpos);
              #77 : if curpos<maxlen then
                    begin
                      if curpos>slen then
                      begin
                        inc(slen);
                        s[curpos]:=' ';
                      end;
                      inc(curpos);
                    end;
              #71 : curpos:=1;
              #79 : if slen<maxlen then curpos:=succ(slen) else curpos:=maxlen;
              #82 : begin
                      ins:=not ins;
                      chgcur(ins);
                    end;
              #83 : if curpos<=slen then delete(s,curpos,1);
            end;
          end;
      #25 : begin
              s:='';
              curpos:=1;
            end;
      #8  : if curpos>1 then
            begin
              dec(curpos);
              delete(s,curpos,1);
            end;
      #13 : begin
              editstring:=true;
              setcursor(16,0);
              trottel:=(cury-1)*160+curx*2-1;
              repeat
                vram[trottel]:=textattr;
                inc(trottel,2);
                dec(maxlen);
              until maxlen=0;
              writeln;
              setcursor(6,7);
              exit;
            end;
      #27 : if enableesc then
            begin
              editstring:=false;
              trottel:=(cury-1)*160+curx*2-1;
              repeat
                vram[trottel]:=textattr;
                inc(trottel,2);
                dec(maxlen);
              until maxlen=0;
              writeln;
              exit;
            end;
    else
      if (pos(ch,charbag)<>0) or (charbag='')  then
      if ins and (slen<maxlen) then
      begin
        insert(ch,s,curpos);
        if curpos<maxlen then inc(curpos);
      end else
      begin
        s[curpos]:=ch;
        if curpos>slen then inc(slen);
        if curpos<maxlen then inc(curpos);
      end;
    end;
    setcursor(16,0);
    gotoxy(curx,cury);
    write(s,'':maxlen-slen);
    trottel:=curx+curpos-2+((cury-1)*80);
    gotoxy(trottel mod 80+1,trottel div 80+1);
  {  gotoxy(curx+curpos-1,cury);  }
    chgcur(ins);
    ch:=readkey;
  until false;
end;

function evalstring(s:string;cb:string;len:byte;def:boolean):boolean;
var
  curx,cury:byte;
  cd:integer;
  helps:string;
  ok:boolean;
  savecb:string;
begin
  curx:=wherex;
  cury:=wherey;
  savecb:=charbag;
  charbag:=cb;
  repeat
    gotoxy(curx,cury);
    helps:=s;
    if not editstring(helps,len,def) then
    begin
      ergint:=0;
      evalstring:=false;
      charbag:=savecb;
      exit;
    end;
    if typ<5 then
    begin
      val(helps,ergint,cd);
      case typ of
        0:ok:=(-128<=ergint) and (ergint<=127);
        1:ok:=(0<=ergint) and (ergint<=255);
        2:ok:=(-32768<=ergint) and (ergint<=32767);
        3:ok:=(0<=ergint) and (ergint<=65535);
        4:ok:=true;
      end;
    end else
    begin
      val(helps,ergreal,cd);
      ok:=true;
    end;
  until (cd=0) and ok;
  evalstring:=true;
  charbag:=savecb;
end;

function readshortint(var retval:shortint;def:boolean):boolean;
begin
  typ:=0;
  if not evalstring(strx(retval),'$-1234567890abcdefABCDEF',4,def) then
  begin
    readshortint:=false;
    exit;
  end;
  retval:=ergint;
  readshortint:=true;
end;

function readbyte(var retval:byte;def:boolean):boolean;
begin
  typ:=1;
  if not evalstring(strx(retval),'$1234567890abcdefABCDEF',3,def) then
  begin
    readbyte:=false;
    exit;
  end;
  retval:=ergint;
  readbyte:=true;
end;

function readint(var retval:integer;def:boolean):boolean;
begin
  typ:=2;
  if not evalstring(strx(retval),'$-1234567890abcdefABCDEF',6,def) then
  begin
    readint:=false;
    exit;
  end;
  retval:=ergint;
  readint:=true;
end;

function readword(var retval:word;def:boolean):boolean;
begin
  typ:=3;
  if not evalstring(strx(retval),'$1234567890abcdefABCDEF',5,def) then
  begin
    readword:=false;
    exit;
  end;
  retval:=ergint;
  readword:=true;
end;

function readlongint(var retval:longint;def:boolean):boolean;
begin
  typ:=4;
  if evalstring(strx(retval),'$-1234567890abcdefABCDEF',11,def) then
  begin
    readlongint:=false;
    exit;
  end;
  retval:=ergint;
  readlongint:=true;
end;

function readreal(var retval:real;def:boolean):boolean;
var
  s:string[17];
begin
  typ:=5;
  str(retval,s);
  s:=copy(s,2,15);
  if not evalstring(s,'+-Ee.1234567890',16,def) then
  begin
    readreal:=false;
    exit;
  end;
  retval:=ergreal;
  readreal:=true;
end;

end.